	  	Perl Mode Completions

Use the 'back-quote' key to jump to the next completion, or just position the 
cursor appropriately, and then hit the completion invoking key ('cmd-tab' 
--default, 'tab' --alternative set).

(a) Here are some typical uses of electric completions:

	for

	foreach

	while
	
	if
	
	else
	
	elsif
	
	do
	
	split
	
(b) These are shortcuts for common perl 'phrases'
	
	o'd
	

(c) When you type a perl scalar, you can add or remove the leading "$" by
    pressing cntrl-4 (i.e. the key that shifts to '$').
	
	type <cntrl-4> several times:
	
	somePerlScalarVar
	
	There is a similar binding for a perl hash (associative array):
	
	type <cntrl-2> several times:
	
	somePerlHash
	
(d) There is also some help available to save typing or mispelling 
    variable names that have already been used at least once.
	
	First let's provide a group of identifiers:
	
	@evcode $evcode @evid *evid $evid @evmask $layout *rowParams 
	%subSection $suffix *tableParams $target 
		
	Now we'll provide examples that extend the first few characters of 
	a indentifier into the full name:
	
	$evc
	
	$lay
	
	ev
	
	
	These examples are different, invoke an expansion (usually cmd-space) 
	on the following identifier anacronyms:
	
	rp
	
	tp
	
	ss
	
(e) After you have entered a lot of code, it can be useful to look at all the 
	identifiers you have used to check for mispelling. There is a Tcl proc 
	that will collect all the identifiers used, sort them alphabetically 
	(disregarding leading $, @, %, and * symbols), and place them on the 
	clipboard. Try it out:
	
	Hilite this word and type Cmd-L: identifiersToScrap_Perl
	
	Note: you would usually enter this via the command line (just invoke,
	<opt-x>, type the some of the command, and use 'tab' completion).
	
	After doing the above, just paste here (Cmd-V):
	
	
(d) It is now possible to use the Tcl shell to invoke MacPerl in a command 
    line fashion. A new "unix shell" like command has been added to help out. 
    Here is an example;
	
		Welcome to Alpha's Tcl shell.
		Alpha . alias sdf [getfile]	
	
	you are presented with a file dialog with which you locate the perl source 
    file 'sdf'. The shell remebers this path, and allows you to make the 
    following call:
	
		Alpha . perl sdf -h

    (note that the ouput appears in the shell window).
	
       